diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/examples/aodv.cc ns-3.38/src/aodv/examples/aodv.cc
--- ns-3.37/src/aodv/examples/aodv.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/examples/aodv.cc	2023-03-16 20:54:23.576868300 -0700
@@ -24,8 +24,8 @@
 #include "ns3/internet-module.h"
 #include "ns3/mobility-module.h"
 #include "ns3/network-module.h"
+#include "ns3/ping-helper.h"
 #include "ns3/point-to-point-module.h"
-#include "ns3/v4ping-helper.h"
 #include "ns3/yans-wifi-helper.h"
 
 #include <cmath>
@@ -46,8 +46,8 @@
  *
  * When 1/3 of simulation time has elapsed, one of the nodes is moved out of
  * range, thereby breaking the topology.  By default, this will result in
- * only 34 of 100 pings being received.  If the step size is reduced
- * to cover the gap, then all pings can be received.
+ * stopping ping replies reception after sequence number 33. If the step size is reduced
+ * to cover the gap, then also the following pings can be received.
  */
 class AodvExample
 {
@@ -234,15 +234,15 @@
     {
         Ptr<OutputStreamWrapper> routingStream =
             Create<OutputStreamWrapper>("aodv.routes", std::ios::out);
-        aodv.PrintRoutingTableAllAt(Seconds(8), routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAllAt(Seconds(8), routingStream);
     }
 }
 
 void
 AodvExample::InstallApplications()
 {
-    V4PingHelper ping(interfaces.GetAddress(size - 1));
-    ping.SetAttribute("Verbose", BooleanValue(true));
+    PingHelper ping(interfaces.GetAddress(size - 1));
+    ping.SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::VERBOSE));
 
     ApplicationContainer p = ping.Install(nodes.Get(0));
     p.Start(Seconds(0));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/model/aodv-id-cache.cc ns-3.38/src/aodv/model/aodv-id-cache.cc
--- ns-3.37/src/aodv/model/aodv-id-cache.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/model/aodv-id-cache.cc	2023-03-16 20:54:23.576868300 -0700
@@ -43,7 +43,7 @@
             return true;
         }
     }
-    struct UniqueId uniqueId = {addr, id, m_lifetime + Simulator::Now()};
+    UniqueId uniqueId = {addr, id, m_lifetime + Simulator::Now()};
     m_idCache.push_back(uniqueId);
     return false;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/model/aodv-id-cache.h ns-3.38/src/aodv/model/aodv-id-cache.h
--- ns-3.37/src/aodv/model/aodv-id-cache.h	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/model/aodv-id-cache.h	2023-03-16 20:54:23.576868300 -0700
@@ -79,7 +79,7 @@
 
     /**
      * Return lifetime for existing entries in cache
-     * \returns thhe lifetime
+     * \returns the lifetime
      */
     Time GetLifeTime() const
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/model/aodv-packet.h ns-3.38/src/aodv/model/aodv-packet.h
--- ns-3.37/src/aodv/model/aodv-packet.h	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/model/aodv-packet.h	2023-03-16 20:54:23.576868300 -0700
@@ -108,6 +108,7 @@
 /**
  * \brief Stream output operator
  * \param os output stream
+ * \param h the TypeHeader
  * \return updated stream
  */
 std::ostream& operator<<(std::ostream& os, const TypeHeader& h);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/model/aodv-routing-protocol.h ns-3.38/src/aodv/model/aodv-routing-protocol.h
--- ns-3.37/src/aodv/model/aodv-routing-protocol.h	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/model/aodv-routing-protocol.h	2023-03-16 20:54:23.576868300 -0700
@@ -260,7 +260,6 @@
                              ///< originated route discovery.
     bool m_enableHello;      ///< Indicates whether a hello messages enable
     bool m_enableBroadcast;  ///< Indicates whether a a broadcast data packets forwarding enable
-    //\}
 
     /// IP protocol
     Ptr<Ipv4> m_ipv4;
@@ -377,8 +376,10 @@
      */
     Ptr<Ipv4Route> LoopbackRoute(const Ipv4Header& header, Ptr<NetDevice> oif) const;
 
-    ///\name Receive control packets
-    //\{
+    /**
+     * \name Receive control packets
+     * @{
+     */
     /**
      * Receive and process control packet
      * \param socket input socket
@@ -410,10 +411,12 @@
      */
     /// Receive  from node with address src
     void RecvError(Ptr<Packet> p, Ipv4Address src);
-    //\}
+    /** @} */
 
-    ///\name Send
-    //\{
+    /**
+     * \name Send
+     * @{
+     */
     /** Forward packet from route request queue
      * \param dst destination address
      * \param route route to use
@@ -459,7 +462,7 @@
      * \param origin originating node IP address
      */
     void SendRerrWhenNoRouteToForward(Ipv4Address dst, uint32_t dstSeqNo, Ipv4Address origin);
-    /// @}
+    /** @} */
 
     /**
      * Send packet to destination socket
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/test/aodv-id-cache-test-suite.cc ns-3.38/src/aodv/test/aodv-id-cache-test-suite.cc
--- ns-3.37/src/aodv/test/aodv-id-cache-test-suite.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/test/aodv-id-cache-test-suite.cc	2023-03-16 20:54:23.576868300 -0700
@@ -33,13 +33,13 @@
 {
 
 /**
- * \ingroup aodv
  * \defgroup aodv-test AODV module tests
+ * \ingroup aodv
+ * \ingroup tests
  */
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for id cache
  */
@@ -111,7 +111,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Id Cache Test Suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/test/aodv-regression.cc ns-3.38/src/aodv/test/aodv-regression.cc
--- ns-3.37/src/aodv/test/aodv-regression.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/test/aodv-regression.cc	2023-03-16 20:54:23.576868300 -0700
@@ -45,7 +45,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief AODV regression test suite
  */
@@ -69,7 +68,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Chain Regression Test
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/test/aodv-test-suite.cc ns-3.38/src/aodv/test/aodv-test-suite.cc
--- ns-3.37/src/aodv/test/aodv-test-suite.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/aodv/test/aodv-test-suite.cc	2023-03-16 20:54:23.576868300 -0700
@@ -30,7 +30,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for neighbors
  */
@@ -136,7 +135,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Type header test case
  */
@@ -164,7 +162,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for RREQ
  */
@@ -224,7 +221,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for RREP
  */
@@ -282,7 +278,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for RREP-ACK
  */
@@ -307,7 +302,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for RERR
  */
@@ -342,7 +336,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for AODV routing table entry
  */
@@ -559,7 +552,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for AODV routing table entry
  */
@@ -653,7 +645,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief Unit test for AODV routing table
  */
@@ -741,7 +732,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief AODV test suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/aodv/test/loopback.cc ns-3.38/src/aodv/test/loopback.cc
--- ns-3.37/src/aodv/test/loopback.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/aodv/test/loopback.cc	2023-03-16 20:54:23.576868300 -0700
@@ -74,7 +74,7 @@
      * Echo data function
      * \param socket The socket to echo data
      */
-    void EchoData(Ptr<Socket> socket);
+    void EchoData(Ptr<Socket> socket) const;
 
   public:
     LoopbackTestCase();
@@ -98,7 +98,7 @@
 }
 
 void
-LoopbackTestCase::EchoData(Ptr<Socket> socket)
+LoopbackTestCase::EchoData(Ptr<Socket> socket) const
 {
     Address from;
     Ptr<Packet> receivedPacket = socket->RecvFrom(std::numeric_limits<uint32_t>::max(), 0, from);
@@ -191,7 +191,6 @@
 
 /**
  * \ingroup aodv-test
- * \ingroup tests
  *
  * \brief AODV Loopback test suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/applications/model/udp-client.cc ns-3.38/src/applications/model/udp-client.cc
--- ns-3.37/src/applications/model/udp-client.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/applications/model/udp-client.cc	2023-03-16 20:54:23.580868500 -0700
@@ -50,11 +50,12 @@
             .SetParent<Application>()
             .SetGroupName("Applications")
             .AddConstructor<UdpClient>()
-            .AddAttribute("MaxPackets",
-                          "The maximum number of packets the application will send",
-                          UintegerValue(100),
-                          MakeUintegerAccessor(&UdpClient::m_count),
-                          MakeUintegerChecker<uint32_t>())
+            .AddAttribute(
+                "MaxPackets",
+                "The maximum number of packets the application will send (zero means infinite)",
+                UintegerValue(100),
+                MakeUintegerAccessor(&UdpClient::m_count),
+                MakeUintegerChecker<uint32_t>())
             .AddAttribute("Interval",
                           "The time to wait between packets",
                           TimeValue(Seconds(1.0)),
@@ -223,7 +224,7 @@
     }
 #endif // NS3_LOG_ENABLE
 
-    if (m_sent < m_count)
+    if (m_sent < m_count || m_count == 0)
     {
         m_sendEvent = Simulator::Schedule(m_interval, &UdpClient::Send, this);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/applications/model/udp-echo-client.cc ns-3.38/src/applications/model/udp-echo-client.cc
--- ns-3.37/src/applications/model/udp-echo-client.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/applications/model/udp-echo-client.cc	2023-03-16 20:54:23.580868500 -0700
@@ -44,11 +44,12 @@
             .SetParent<Application>()
             .SetGroupName("Applications")
             .AddConstructor<UdpEchoClient>()
-            .AddAttribute("MaxPackets",
-                          "The maximum number of packets the application will send",
-                          UintegerValue(100),
-                          MakeUintegerAccessor(&UdpEchoClient::m_count),
-                          MakeUintegerChecker<uint32_t>())
+            .AddAttribute(
+                "MaxPackets",
+                "The maximum number of packets the application will send (zero means infinite)",
+                UintegerValue(100),
+                MakeUintegerAccessor(&UdpEchoClient::m_count),
+                MakeUintegerChecker<uint32_t>())
             .AddAttribute("Interval",
                           "The time to wait between packets",
                           TimeValue(Seconds(1.0)),
@@ -391,7 +392,7 @@
                        << Inet6SocketAddress::ConvertFrom(m_peerAddress).GetPort());
     }
 
-    if (m_sent < m_count)
+    if (m_sent < m_count || m_count == 0)
     {
         ScheduleTransmit(m_interval);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/applications/model/udp-trace-client.cc ns-3.38/src/applications/model/udp-trace-client.cc
--- ns-3.37/src/applications/model/udp-trace-client.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/applications/model/udp-trace-client.cc	2023-03-16 20:54:23.580868500 -0700
@@ -48,16 +48,18 @@
 /**
  * \brief Default trace to send
  */
-struct UdpTraceClient::TraceEntry UdpTraceClient::g_defaultEntries[] = {{0, 534, 'I'},
-                                                                        {40, 1542, 'P'},
-                                                                        {120, 134, 'B'},
-                                                                        {80, 390, 'B'},
-                                                                        {240, 765, 'P'},
-                                                                        {160, 407, 'B'},
-                                                                        {200, 504, 'B'},
-                                                                        {360, 903, 'P'},
-                                                                        {280, 421, 'B'},
-                                                                        {320, 587, 'B'}};
+struct UdpTraceClient::TraceEntry UdpTraceClient::g_defaultEntries[] = {
+    {0, 534, 'I'},
+    {40, 1542, 'P'},
+    {120, 134, 'B'},
+    {80, 390, 'B'},
+    {240, 765, 'P'},
+    {160, 407, 'B'},
+    {200, 504, 'B'},
+    {360, 903, 'P'},
+    {280, 421, 'B'},
+    {320, 587, 'B'},
+};
 
 TypeId
 UdpTraceClient::GetTypeId()
@@ -149,7 +151,7 @@
 UdpTraceClient::SetTraceFile(std::string traceFile)
 {
     NS_LOG_FUNCTION(this << traceFile);
-    if (traceFile == "")
+    if (traceFile.empty())
     {
         LoadDefaultTrace();
     }
@@ -229,9 +231,9 @@
 {
     NS_LOG_FUNCTION(this);
     uint32_t prevTime = 0;
-    for (uint32_t i = 0; i < (sizeof(g_defaultEntries) / sizeof(struct TraceEntry)); i++)
+    for (uint32_t i = 0; i < (sizeof(g_defaultEntries) / sizeof(TraceEntry)); i++)
     {
-        struct TraceEntry entry = g_defaultEntries[i];
+        TraceEntry entry = g_defaultEntries[i];
         if (entry.frameType == 'B')
         {
             entry.timeToSend = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/applications/model/udp-trace-client.h ns-3.38/src/applications/model/udp-trace-client.h
--- ns-3.37/src/applications/model/udp-trace-client.h	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/applications/model/udp-trace-client.h	2023-03-16 20:54:23.580868500 -0700
@@ -165,9 +165,9 @@
     uint16_t m_peerPort;   //!< Remote peer port
     EventId m_sendEvent;   //!< Event to send the next packet
 
-    std::vector<struct TraceEntry> m_entries;    //!< Entries in the trace to send
-    uint32_t m_currentEntry;                     //!< Current entry index
-    static struct TraceEntry g_defaultEntries[]; //!< Default trace to send
+    std::vector<TraceEntry> m_entries;    //!< Entries in the trace to send
+    uint32_t m_currentEntry;              //!< Current entry index
+    static TraceEntry g_defaultEntries[]; //!< Default trace to send
     uint16_t m_maxPacketSize; //!< Maximum packet size to send (including the SeqTsHeader)
     bool m_traceLoop;         //!< Loop through the trace file
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/applications/test/bulk-send-application-test-suite.cc ns-3.38/src/applications/test/bulk-send-application-test-suite.cc
--- ns-3.37/src/applications/test/bulk-send-application-test-suite.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/applications/test/bulk-send-application-test-suite.cc	2023-03-16 20:54:23.580868500 -0700
@@ -173,8 +173,8 @@
     uint64_t m_received{0};      //!< number of bytes received
     uint64_t m_seqTxCounter{0};  //!< Counter for Sequences on Tx
     uint64_t m_seqRxCounter{0};  //!< Counter for Sequences on Rx
-    Time m_lastTxTs{Seconds(0)}; //!< Last recored timestamp on Tx
-    Time m_lastRxTs{Seconds(0)}; //!< Last recored timestamp on Rx
+    Time m_lastTxTs{Seconds(0)}; //!< Last recorded timestamp on Tx
+    Time m_lastRxTs{Seconds(0)}; //!< Last recorded timestamp on Rx
 };
 
 BulkSendSeqTsSizeTestCase::BulkSendSeqTsSizeTestCase()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/applications/test/udp-client-server-test.cc ns-3.38/src/applications/test/udp-client-server-test.cc
--- ns-3.37/src/applications/test/udp-client-server-test.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/applications/test/udp-client-server-test.cc	2023-03-16 20:54:23.580868500 -0700
@@ -330,13 +330,13 @@
 
     ApplicationContainer clientApps = echoClient.Install(nodes.Get(0));
 
-    uint8_t arry[64];
+    uint8_t array[64];
     uint8_t i;
     for (i = 0; i < 64; i++)
     {
-        arry[i] = i;
+        array[i] = i;
     }
-    echoClient.SetFill(clientApps.Get(0), &(arry[0]), (uint32_t)64, (uint32_t)64);
+    echoClient.SetFill(clientApps.Get(0), &(array[0]), (uint32_t)64, (uint32_t)64);
 
     clientApps.Start(Seconds(2.0));
     clientApps.Stop(Seconds(10.0));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/bridge/examples/csma-bridge.cc ns-3.38/src/bridge/examples/csma-bridge.cc
--- ns-3.37/src/bridge/examples/csma-bridge.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/bridge/examples/csma-bridge.cc	2023-03-16 20:54:23.580868500 -0700
@@ -167,4 +167,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/bridge/examples/csma-bridge-one-hop.cc ns-3.38/src/bridge/examples/csma-bridge-one-hop.cc
--- ns-3.37/src/bridge/examples/csma-bridge-one-hop.cc	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/bridge/examples/csma-bridge-one-hop.cc	2023-03-16 20:54:23.580868500 -0700
@@ -16,7 +16,7 @@
 // Network topology
 //
 //         bridge1         The node named bridge1 (node 5 in the nodelist)
-//   ------------------        has three CMSA net devices that are bridged
+//   ------------------        has three CSMA net devices that are bridged
 //   CSMA   CSMA   CSMA        together using a BridgeNetDevice.
 //     |      |      |
 //     |      |      |     The bridge node talks over three CSMA channels
@@ -34,7 +34,7 @@
 //     |      |      |
 //     |      |      |
 //   CSMA   CSMA   CSMA    The node named bridge2 (node 6 in the nodelist)
-//   ------------------        has three CMSA net devices that are bridged
+//   ------------------        has three CSMA net devices that are bridged
 //        bridge2              together using a BridgeNetDevice.
 //
 // Or, more abstractly, recognizing that bridge 1 and bridge 2 are nodes
@@ -238,4 +238,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/bridge/examples/csma-bridge.py ns-3.38/src/bridge/examples/csma-bridge.py
--- ns-3.37/src/bridge/examples/csma-bridge.py	2022-11-01 17:37:24.455395000 -0700
+++ ns-3.38/src/bridge/examples/csma-bridge.py	2023-03-16 20:54:23.580868500 -0700
@@ -96,8 +96,7 @@
     port = 9   # Discard port(RFC 863)
 
     inet_sock_address = ns.network.InetSocketAddress(ns.network.Ipv4Address("10.1.1.2"), port)
-    onoff = ns.applications.OnOffHelper("ns3::UdpSocketFactory",
-                            ns.network.Address(ns.addressFromInetSocketAddress(inet_sock_address)))
+    onoff = ns.applications.OnOffHelper("ns3::UdpSocketFactory", inet_sock_address.ConvertTo())
     onoff.SetConstantRate (ns.network.DataRate ("500kb/s"))
 
     app = onoff.Install(ns.network.NodeContainer(terminals.Get(0)))
@@ -107,8 +106,7 @@
 
     # Create an optional packet sink to receive these packets
     inet_address = ns.network.InetSocketAddress(ns.network.Ipv4Address.GetAny(), port)
-    sink = ns.applications.PacketSinkHelper("ns3::UdpSocketFactory",
-                                ns.network.Address(ns.addressFromInetSocketAddress(inet_address)))
+    sink = ns.applications.PacketSinkHelper("ns3::UdpSocketFactory", inet_address.ConvertTo())
     app = sink.Install(ns.network.NodeContainer(terminals.Get(1)))
     app.Start(ns.core.Seconds(0.0))
 
@@ -117,7 +115,7 @@
     #
     inet_address = ns.network.InetSocketAddress(ns.network.Ipv4Address("10.1.1.1"), port)
     onoff.SetAttribute("Remote",
-                       ns.network.AddressValue(ns.addressFromInetSocketAddress(inet_address)))
+                       ns.network.AddressValue(inet_address.ConvertTo()))
     app = onoff.Install(ns.network.NodeContainer(terminals.Get(3)))
     app.Start(ns.core.Seconds(1.1))
     app.Stop(ns.core.Seconds(10.0))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/brite/CMakeLists.txt ns-3.38/src/brite/CMakeLists.txt
--- ns-3.37/src/brite/CMakeLists.txt	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/brite/CMakeLists.txt	2023-03-16 20:54:23.580868500 -0700
@@ -18,8 +18,10 @@
 
 if((NOT
     brite_FOUND)
-   OR (NOT
-       ${brite_FOUND})
+   AND (NOT
+        ${brite_FOUND})
+   AND (NOT
+        ${NS3_FETCH_OPTIONAL_COMPONENTS})
 )
   message(
     ${HIGHLIGHTED_STATUS}
@@ -28,6 +30,12 @@
   return()
 endif()
 
+if(${NS3_FETCH_OPTIONAL_COMPONENTS})
+  set(brite_LIBRARIES
+      brite
+  )
+endif()
+
 # Only process module if include folder and library have been found
 include_directories(${brite_INCLUDE_DIRS})
 set(NS3_BRITE
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/brite/examples/brite-generic-example.cc ns-3.38/src/brite/examples/brite-generic-example.cc
--- ns-3.37/src/brite/examples/brite-generic-example.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/brite/examples/brite-generic-example.cc	2023-03-16 20:54:23.580868500 -0700
@@ -14,6 +14,8 @@
  *
  */
 
+#include "Brite.h"
+
 #include "ns3/applications-module.h"
 #include "ns3/brite-module.h"
 #include "ns3/core-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/brite/examples/brite-MPI-example.cc ns-3.38/src/brite/examples/brite-MPI-example.cc
--- ns-3.37/src/brite/examples/brite-MPI-example.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/brite/examples/brite-MPI-example.cc	2023-03-16 20:54:23.580868500 -0700
@@ -14,6 +14,8 @@
  *
  */
 
+#include "Brite.h"
+
 #include "ns3/applications-module.h"
 #include "ns3/brite-module.h"
 #include "ns3/core-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/brite/helper/brite-topology-helper.cc ns-3.38/src/brite/helper/brite-topology-helper.cc
--- ns-3.37/src/brite/helper/brite-topology-helper.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/brite/helper/brite-topology-helper.cc	2023-03-16 20:54:23.580868500 -0700
@@ -16,6 +16,8 @@
 
 #include "brite-topology-helper.h"
 
+#include "Brite.h"
+
 #include "ns3/abort.h"
 #include "ns3/data-rate.h"
 #include "ns3/ipv4-address-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/brite/helper/brite-topology-helper.h ns-3.38/src/brite/helper/brite-topology-helper.h
--- ns-3.37/src/brite/helper/brite-topology-helper.h	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/brite/helper/brite-topology-helper.h	2023-03-16 20:54:23.580868500 -0700
@@ -28,8 +28,12 @@
 #include <string>
 #include <vector>
 
-// located in BRITE source directory
-#include "Brite.h"
+// These are in #include <Brite.h>,
+// here we just need a forward declaration.
+namespace brite
+{
+struct Topology;
+};
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/examples/buildings-pathloss-profiler.cc ns-3.38/src/buildings/examples/buildings-pathloss-profiler.cc
--- ns-3.37/src/buildings/examples/buildings-pathloss-profiler.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/examples/buildings-pathloss-profiler.cc	2023-03-16 20:54:23.580868500 -0700
@@ -95,4 +95,6 @@
     }
 
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/examples/outdoor-group-mobility-example.cc ns-3.38/src/buildings/examples/outdoor-group-mobility-example.cc
--- ns-3.37/src/buildings/examples/outdoor-group-mobility-example.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/examples/outdoor-group-mobility-example.cc	2023-03-16 20:54:23.580868500 -0700
@@ -98,7 +98,7 @@
 /**
  * Print the buildings list in a format that can be used by Gnuplot to draw them.
  *
- * \param filename The ouput filename.
+ * \param filename The output filename.
  */
 void
 PrintGnuplottableBuildingListToFile(std::string filename)
@@ -279,4 +279,6 @@
     Simulator::Run();
     g_timeSeries.close();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/examples/outdoor-random-walk-example.cc ns-3.38/src/buildings/examples/outdoor-random-walk-example.cc
--- ns-3.37/src/buildings/examples/outdoor-random-walk-example.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/examples/outdoor-random-walk-example.cc	2023-03-16 20:54:23.580868500 -0700
@@ -31,7 +31,7 @@
 /**
  * Print the buildings list in a format that can be used by Gnuplot to draw them.
  *
- * \param filename The ouput filename.
+ * \param filename The output filename.
  */
 void
 PrintGnuplottableBuildingListToFile(std::string filename)
@@ -131,4 +131,6 @@
     Simulator::Stop(Seconds(1e4));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/helper/building-container.h ns-3.38/src/buildings/helper/building-container.h
--- ns-3.37/src/buildings/helper/building-container.h	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/helper/building-container.h	2023-03-16 20:54:23.580868500 -0700
@@ -137,7 +137,7 @@
      * Buildings can be retrieved from the container in two ways.  First,
      * directly by an index into the container, and second, using an iterator.
      * This method is used in the direct method and is used to retrieve the
-     * indexed Ptr<Appliation>.
+     * indexed Ptr<Application>.
      *
      * \code
      *   uint32_t nBuildings = container.GetN ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/helper/building-position-allocator.h ns-3.38/src/buildings/helper/building-position-allocator.h
--- ns-3.37/src/buildings/helper/building-position-allocator.h	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/helper/building-position-allocator.h	2023-03-16 20:54:23.580868500 -0700
@@ -162,7 +162,7 @@
 
   private:
     /**
-     * Room informations
+     * Room information
      */
     struct RoomInfo
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/model/building-list.cc ns-3.38/src/buildings/model/building-list.cc
--- ns-3.37/src/buildings/model/building-list.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/model/building-list.cc	2023-03-16 20:54:23.580868500 -0700
@@ -55,13 +55,13 @@
      */
     uint32_t Add(Ptr<Building> building);
     /**
-     * Returns an interator to the start of the list.
+     * Returns an iterator to the start of the list.
      *
      * \returns iterator to the begin of the container.
      */
     BuildingList::Iterator Begin() const;
     /**
-     * Returns an interator to the end of the list.
+     * Returns an iterator to the end of the list.
      *
      * \returns iterator to the end of the container.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/model/buildings-channel-condition-model.cc ns-3.38/src/buildings/model/buildings-channel-condition-model.cc
--- ns-3.37/src/buildings/model/buildings-channel-condition-model.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/model/buildings-channel-condition-model.cc	2023-03-16 20:54:23.584868400 -0700
@@ -105,7 +105,7 @@
     {
         cond->SetO2iCondition(ChannelCondition::O2iConditionValue::O2I);
 
-        NS_LOG_DEBUG("a is indoor and b outdoor or viceversa");
+        NS_LOG_DEBUG("a is indoor and b outdoor or vice-versa");
         cond->SetLosCondition(ChannelCondition::LosConditionValue::NLOS);
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/model/hybrid-buildings-propagation-loss-model.cc ns-3.38/src/buildings/model/hybrid-buildings-propagation-loss-model.cc
--- ns-3.37/src/buildings/model/hybrid-buildings-propagation-loss-model.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/model/hybrid-buildings-propagation-loss-model.cc	2023-03-16 20:54:23.584868400 -0700
@@ -174,7 +174,7 @@
                 }
                 else
                 {
-                    // Over the rooftop tranmission -> Okumura Hata
+                    // Over the rooftop transmission -> Okumura Hata
                     loss = OkumuraHata(a, b);
                     NS_LOG_INFO(this << " O-O (>1000): above rooftop -> OH : " << loss);
                 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/model/random-walk-2d-outdoor-mobility-model.h ns-3.38/src/buildings/model/random-walk-2d-outdoor-mobility-model.h
--- ns-3.37/src/buildings/model/random-walk-2d-outdoor-mobility-model.h	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/model/random-walk-2d-outdoor-mobility-model.h	2023-03-16 20:54:23.584868400 -0700
@@ -124,7 +124,7 @@
 
     ConstantVelocityHelper m_helper;       //!< helper for this object
     EventId m_event;                       //!< stored event ID
-    enum Mode m_mode;                      //!< whether in time or distance mode
+    Mode m_mode;                           //!< whether in time or distance mode
     double m_modeDistance;                 //!< Change direction and speed after this distance
     Time m_modeTime;                       //!< Change current direction and speed after this delay
     Ptr<RandomVariableStream> m_speed;     //!< rv for picking speed
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/test/buildings-channel-condition-model-test.cc ns-3.38/src/buildings/test/buildings-channel-condition-model-test.cc
--- ns-3.37/src/buildings/test/buildings-channel-condition-model-test.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/test/buildings-channel-condition-model-test.cc	2023-03-16 20:54:23.584868400 -0700
@@ -59,14 +59,14 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         Vector m_positionA;                            //!< the position of the first node
         Vector m_positionB;                            //!< the position of the second node
         ChannelCondition::LosConditionValue m_losCond; //!< the correct channel condition
-    } TestVector;
+    };
 
-    TestVectors<TestVector> m_testVectors; //!< array containg all the test vectors
+    TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
 };
 
 BuildingsChannelConditionModelTestCase::BuildingsChannelConditionModelTestCase()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/test/buildings-pathloss-test.h ns-3.38/src/buildings/test/buildings-pathloss-test.h
--- ns-3.37/src/buildings/test/buildings-pathloss-test.h	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/test/buildings-pathloss-test.h	2023-03-16 20:54:23.584868400 -0700
@@ -55,7 +55,7 @@
      * \param freq Communication frequency
      * \param m1 First MobilityModel Index
      * \param m2 Second MobilityModel Index
-     * \param env Enviroment type
+     * \param env Environment type
      * \param city City size
      * \param refValue Theoretical loss
      * \param name Test name
@@ -81,7 +81,7 @@
     double m_freq;                  //!< Communication frequency
     uint16_t m_mobilityModelIndex1; //!< First MobilityModel Index
     uint16_t m_mobilityModelIndex2; //!< Second MobilityModel Index
-    EnvironmentType m_env;          //!< Enviroment type
+    EnvironmentType m_env;          //!< Environment type
     CitySize m_city;                //!< City size
     double m_lossRef;               //!< Theoretical loss
 };
